module.exports = function(_, options = {}) {
  return {
    presets: [
      [
        '@babel/preset-env',
        {
          useBuiltIns: 'usage',
          corejs: 3,
          ...options['@babel/preset-env'],
        },
      ],
      [
        '@babel/preset-react',
        {
          ...options['@babel/preset-react'],
        },
      ]
    ],
    plugins: [
			//
			// TC39 Proposals
			//
      // Stage 4: https://github.com/tc39/proposal-object-rest-spread
      '@babel/plugin-proposal-object-rest-spread',
      // Stage 3: https://github.com/tc39/proposal-class-fields
      // Stage 3: https://github.com/tc39/proposal-static-class-features
      '@babel/plugin-proposal-class-properties',
      // Stage 3: https://github.com/tc39/proposal-nullish-coalescing
      '@babel/plugin-proposal-nullish-coalescing-operator',
      // Stage 3: https://github.com/tc39/proposal-optional-chaining
      '@babel/plugin-proposal-optional-chaining',

      //
      // Syntax support for Webpack
      //
      // Adds support for dynamic imports and code splitting
      // https://webpack.js.org/guides/code-splitting/#dynamic-imports
      // https://babeljs.io/docs/en/babel-plugin-syntax-dynamic-import
      '@babel/plugin-syntax-dynamic-import',
    ],
  };
}
